#!/usr/bin/tcl -f

###########################################
#    BRIDGES FINDER                       #
#    MOST DUMMY Tcl SCRIPT EVER           #
#    HOWEVER IT WORKS!!!                  #
#    Copyright(C) 2002 Alexander Kozik    #
#    email akozik@atgc.org                #
###########################################

proc Check_Bad_Matrix_Step2 { seq_IDs_list } {

    global matrix_to_validate input_file_to_check \
            validated_matrix 

    set matrix_file_to_write [open "$validated_matrix" "w"]
    set matrix_file_to_open [open "$matrix_to_validate" "r"]

    while {[gets $matrix_file_to_open matrix_current_line] >= 0}  {
        set matrix_ID_A [lindex $matrix_current_line 0]
        set matrix_ID_B [lindex $matrix_current_line 1]
        set is_it_here_A [lsearch -exact $seq_IDs_list $matrix_ID_A]
        set is_it_here_B [lsearch -exact $seq_IDs_list $matrix_ID_B]
        if {$is_it_here_A >=0 && $is_it_here_B >=0} {
            puts $matrix_file_to_write $matrix_current_line
        }
    }
    close $matrix_file_to_write
    close $matrix_file_to_open
    puts "**************************"
    puts "*  Submatrix Created!!!  *"
    puts "**************************"
    FindBridges_Finale_Round_A
}

proc Check_Bad_Matrix {} {

    global matrix_to_validate input_file_to_check \
            validated_matrix

    set validated_matrix "temporary_matrix_file.genopix"
    set seq_IDs_list $input_file_to_check

    Check_Bad_Matrix_Step2 $seq_IDs_list

}

proc FindBridges_Finale_Round_A {} {

###########################
# BUILDING ADJACENCY LIST #
###########################

    global matrix_file_to_write
    global dummy_counter
    global input_file_to_check
    global adj_query_file
    global adj_query_file_open

    puts "*****************************"
    puts "DUMMY COUNTER: $dummy_counter"
    puts "*****************************"

#############################

    set adj_query_file "temporary_adj_list.genopix"
    set adj_query_file_open [open $adj_query_file "w"]

    set size_of_list [llength [split $input_file_to_check]]

    while {$size_of_list >= 0} {
        set current_line [lindex [split $input_file_to_check] [expr $size_of_list -1]]
	puts -nonewline $adj_query_file_open $current_line\|
        Adj_List_Extraction $current_line
	puts -nonewline $adj_query_file_open \n
	puts $size_of_list 
	incr size_of_list -1
    }

#############################

    puts "*******************************"
    puts "*  Adjacency List Created!!!  *"
    puts "*******************************"

    close $adj_query_file_open
    incr dummy_counter

    FindBridges_Finale_Round_B

}

proc FindBridges_Finale_Round_B {} {

    global used_nodes_list
    global current_node_minus
    global current_minus_one_list
    global bridges_list_output
    global bridges_list_output_open
    global input_file_to_check
    global round_2_counter
    global dummy_counter

    set size_of_list [llength [split $input_file_to_check]]
    set m 0

    puts "***************************"
    puts "$dummy_counter Nodes were analyzed"
    puts "Finding Bridges in Progress"
    puts "***************************"

    while {$size_of_list >= 0} {
	set current_seq_ID [lindex [split $input_file_to_check] [expr $size_of_list -1]]
        if { $m == 0 } {
            set used_nodes_list [lappend used_nodes_list ""]
        }
        set already_done [lsearch -exact $used_nodes_list $current_seq_ID]
	if {$already_done < 0} {
		    set used_nodes_list [lappend used_nodes_list "$current_seq_ID"]
		    set used_nodes_list_length [llength [split $used_nodes_list]]
		    incr m
		    set group_members_counter 1
		    DFS_Procedure $current_seq_ID $m 
	    if {$m > 1} {
		puts "***********************************"
		puts "$current_node_minus is a Bridge !!!"
		puts "***********************************"
		puts $bridges_list_output_open "$current_node_minus is a Bridge !!!"
	    }
	}
	if {$already_done >= 0} {
	    set used_nodes_list_length [llength [split $used_nodes_list]]
	}
	incr size_of_list -1
    }
    unset used_nodes_list
    unset m
}

proc Already_Done {current_node_ID} {

    global used_nodes_list

    set already_done [lsearch -exact $used_nodes_list $current_node_ID]
    if {$already_done < 0} {
	set used_nodes_list [lappend used_nodes_list "$current_node_ID"]
    }
    if {$already_done >= 0} {
	continue
    }
}


proc DFS_Procedure {first_id m} {

    global query_file
    global used_nodes_list 
    global group_file_open
    global adj_query_file
    global adj_query_file_open

    set l 1
    set group_counter 1
    set current_query_file_open [open $adj_query_file "r"]
	while {[gets $current_query_file_open current_adj_line] >= 0} {
	    set current_adj_list [split $current_adj_line "|"]
	    set perfect_match [lsearch -exact $current_adj_list $first_id]
	    if {$perfect_match >= 0} {
		set current_adj_line_length [expr [llength [split $current_adj_line "|"]] - 1]
		while {$current_adj_line_length >= 0} {
		    set current_node_ID [lindex [split $current_adj_line "|"] [expr $current_adj_line_length -1]]
		    set already_done [lsearch -exact $used_nodes_list $current_node_ID]
		    if {$already_done < 0 && $current_node_ID != ""} {
			Already_Done $current_node_ID
			DFS_Procedure $current_node_ID $m
		    }
		    incr current_adj_line_length -1
		}
	    }
	incr l
	}
    close $current_query_file_open
}

proc Check_Bridges {current_minus_one_list current_node_minus} {

    global matrix_to_validate 
    global input_file_to_check 
    global validated_matrix
    global matrix_to_process

    set input_file_to_check $current_minus_one_list 
    set matrix_to_validate $matrix_to_process

    Check_Bad_Matrix

}

proc Create_Minus_One_List {full_node_list k} {

global current_node_minus
global current_minus_one_list

    while {$k >=1} {
	set current_node_minus [lindex [split $full_node_list] [expr $k-1]]
	set current_minus_one_list [lreplace $full_node_list [expr $k-1] [expr $k-1]]
	puts "*******************************************************"
	puts "$k\t$current_node_minus ... Creating \"Minus One List\""
	puts "*******************************************************"
	Check_Bridges $current_minus_one_list $current_node_minus
	incr k -1
    }
}

proc Create_ID_List {} {

    global input_file_to_process

    set process_full_list [open "$input_file_to_process" "r"]
    set k 0
    while {[gets $process_full_list current_line] >= 0}  {
	set full_node_list [lappend full_node_list $current_line]
	incr k
    }
    close $process_full_list
    Create_Minus_One_List $full_node_list $k
}

############################################

proc Adj_List_Extraction {current_line} {

    global input_file_to_check
    global adj_query_file
    global adj_query_file_open
    global validated_matrix

    set matrix_to_process [open "$validated_matrix" "r"]

    while {[gets $matrix_to_process current_matrix_line] >= 0}  {
	set matrix_id_A [lindex [split $current_matrix_line] 0]
	set matrix_id_B [lindex [split $current_matrix_line] 1]
	set current_sim_value [lindex [split $current_matrix_line] 2]
	if {$current_line == $matrix_id_A} {
	    puts -nonewline $adj_query_file_open $matrix_id_B\|
	}
	if {$current_line == $matrix_id_B} {
	    puts -nonewline $adj_query_file_open $matrix_id_A\|
	}
	if {$current_line != $matrix_id_A && $current_line != $matrix_id_B} {
	continue
	}
    }
    close $matrix_to_process
}


############################################

################################
#                              #
#          MAIN BODY           #
#                              #
################################

global input_file_to_process
global matrix_to_process
global bridges_list_output
global bridges_list_output_open
global dummy_counter

################################
# standard input/output dialog #

set dummy_counter 0

puts -nonewline "Enter the LIST file name: "
flush stdout

set input_file_to_process [gets stdin]

while {[catch {set f_in1 [open "$input_file_to_process"  "r"]}] == 1} {
        puts stderr "Error opening $input_file_to_process"
        puts -nonewline "Please re-enter the LIST file name: "
        flush stdout
        set input_file_to_process [gets stdin]
}

close $f_in1

puts -nonewline "Enter the MATRIX file name: "
flush stdout

set matrix_to_process [gets stdin]

while {[catch {set f_in2 [open "$matrix_to_process"  "r"]}] == 1} {
        puts stderr "Error opening $matrix_to_process"
        puts -nonewline "Please re-enter the MATRIX file name: "
        flush stdout
        set matrix_to_process [gets stdin]
}

close $f_in2

puts -nonewline "Enter the OUTPUT file name (Bridges List): "
flush stdout
set bridges_list_output [gets stdin]

set bridges_list_output_open [open $bridges_list_output "w"]

# end of input/output dialog #
##############################

Create_ID_List

close $bridges_list_output_open

puts "!!! XPEH BAM !!!"
puts "!!!  KPACOTA !!!"
puts "!!! TAK TO ..!!!"