#!/usr/bin/tcl -f

proc Matrix_Validator {} {

    global matrix_to_validate input_file_to_check validated_matrix

    Check_Bad_Matrix_New

}

##########################

proc Check_Bad_Matrix_New {} {

    global matrix_to_validate input_file_to_check \
            validated_matrix 

    set input_file_to_open [open "$input_file_to_check" "r"]

    set seq_IDs_list ""

    while {[gets $input_file_to_open current_line] >= 0}  {

        set current_seq_ID [lindex $current_line 0]
        set seq_IDs_list [lappend seq_IDs_list "$current_seq_ID"]
#       puts $seq_IDs_list
    }
    close $input_file_to_open
    Check_Bad_Matrix_Step2 $seq_IDs_list
}

proc Check_Bad_Matrix_Step2 { seq_IDs_list } {

    global matrix_to_validate input_file_to_check \
            validated_matrix identity_cutoff_value

    set k 0

    set matrix_file_to_write [open "$validated_matrix" "w"]
    set matrix_file_to_open [open "$matrix_to_validate" "r"]

    while {[gets $matrix_file_to_open matrix_current_line] >= 0}  {
        set matrix_ID_A [lindex $matrix_current_line 0]
        set matrix_ID_B [lindex $matrix_current_line 1]
	set current_identity [lindex $matrix_current_line 2]
        set is_it_here_A [lsearch -exact $seq_IDs_list $matrix_ID_A]
        set is_it_here_B [lsearch -exact $seq_IDs_list $matrix_ID_B]
        if {$is_it_here_A >=0 && $is_it_here_B >=0 && $current_identity >= $identity_cutoff_value} {
            puts $matrix_file_to_write $matrix_current_line
        }
        incr k
	puts $k
    }
    close $matrix_file_to_write
    close $matrix_file_to_open
    puts "Done!"
}

################################

global matrix_to_validate input_file_to_check \
    validated_matrix identity_cutoff_value

################################
# standard input/output dialog #

puts -nonewline "Enter the LIST file name: "
flush stdout

set input_file_to_check [gets stdin]

while {[catch {set f_in1 [open "$input_file_to_check"  "r"]}] == 1} {
        puts stderr "Error opening $input_file_to_check"
        puts -nonewline "Please re-enter the LIST file name: "
        flush stdout
        set input_file_to_check [gets stdin]
}

close $f_in1

puts -nonewline "Enter the MATRIX file name: "
flush stdout

set matrix_to_validate [gets stdin]

while {[catch {set f_in2 [open "$matrix_to_validate"  "r"]}] == 1} {
        puts stderr "Error opening $matrix_to_validate"
        puts -nonewline "Please re-enter the SEQUNCE file name: "
        flush stdout
        set matrix_to_validate [gets stdin]
}

close $f_in2

puts -nonewline "Enter the CUTOFF value (0.5): "
flush stdout
set identity_cutoff_value [gets stdin]

puts -nonewline "Enter the OUTPUT file name (Validated Matrix): "
flush stdout
set validated_matrix [gets stdin]

# end of input/output dialog #
##############################

Matrix_Validator

##############################
